/*
 * memtest.c
 * 12/10/93
 * Chase COH memory handling bug.
 */

#include <stdlib.h>

#define	BUFS	1024			/* plenty of buffers */
#define	CHUNK	(640 * 480)		/* a VGA screen buffer, for example */

char	*buf[1024];			/* buffers */
int	nbuf;				/* number of buffers */
long	t0;				/* invocation time */

main()
{
	register int i, j, count;
	register long t;
	register char *s;

	t0 = time(NULL);
	while ((buf[nbuf] = malloc(CHUNK)) != NULL) {
#if	DEBUG
		printf("buf[%d]:\t0x%X\n", nbuf, buf[nbuf]);
#endif
		nbuf++;
	}
	printf("allocated %d buffers\n", nbuf);
	for (count = 1; ; ++count) {
		if (count % 100 == 0) {
			if (count % 1000 == 0)
				printf("count=%d\n", count);
			s = malloc(CHUNK);
			if (s != NULL)
				printf("got another:\t0x%X\n", s);
		}
		t = time(NULL) - t0;
		i = rand() % nbuf;
		do {
			j = rand() % nbuf;
		} while (i == j);
#if	DEBUG
		printf("%d:%02d\tcopy %d to %d\n", t / 60, t % 60, j, i);
#endif
		memcpy(buf[i], buf[j], CHUNK);
	}
}

/* end of memtest.c */
