/*
 * scr_clip.c
 */

#include "screen.h"

/* Globals. */
char	*screen0;			/* &screen[src_y0][scr_x0]	*/
int	scr_lrx;			/* lrx of clipping window	*/
int	scr_lry;			/* lry of clipping window	*/
int	scr_ulx;			/* ulx of clipping window	*/
int	scr_uly;			/* uly of clipping window	*/
int	scr_x0;				/* x of center of window	*/
int	scr_xdim;			/* x pixels on window		*/
int	scr_xymax;			/* max(scr_xdim, scr_ydim)	*/
int	scr_ydim;			/* y pixels on window		*/
int	scr_y0;				/* y of center of window	*/

/*
 * Define a rudimentary rectangular clipping window.
 * Compute constants which depend on the clipping window.
 * The clipping window gets used by
 * scr_pixel(), scr_circle(), scr_rectangle() and scr_effect().
 */
void
scr_clip(ulx, uly, lrx, lry) int ulx, uly, lrx, lry;
{
	scr_ulx = (ulx >= 0) ? ulx : 0;
	scr_uly = (uly >= 0) ? uly : 0;
	scr_lrx = (lrx < scr_xmax) ? lrx : scr_xmax - 1;
	scr_lry = (lry < scr_ymax) ? lry : scr_ymax - 1;
	scr_xdim = scr_lrx + 1 - scr_ulx;
	scr_ydim = scr_lry + 1 - scr_uly;
	scr_x0 = scr_ulx + scr_xdim / 2;
	scr_y0 = scr_uly + scr_ydim / 2;
	screen0 = scr_addr(scr_x0, scr_y0);
	scr_xymax = (scr_xdim >= scr_ydim) ? scr_xdim : scr_ydim;
}

/* end of scr_clip.c */
