/*
 * scr_fillcirc.c
 */

#include "screen.h"
#include <math.h>

/*
 * Fill a circle centered at (x0, y0) with radius r in the given color.
 * This is more efficient than scr_fillcirc() with width r.
 */
void
scr_fillcircle(x0, y0, r, color) int x0, y0, r, color;
{
	register int n, y, rsq, count, x1, x2;

	rsq = r * r;
	for (n = -r, y = y0 - r; n <= r; n++, y++) {
		if (y < scr_uly)
			continue;
		else if (y > scr_lry)
			break;
		count = (int)(.5 + sqrt((double)(rsq - n * n)));
		if ((x1 = x0 - count) < scr_ulx)
			x1 = scr_ulx;
		if ((x2 = x0 + count) > scr_lrx)
			x2 = scr_lrx;
		if (x1 > x2)
			continue;
		memset(scr_addr(x1, y), color, x2 - x1 + 1);
	}
}

/* end of scr_fillcirc.c */
