/*
 * scr_fillrect.c
 */

#include "screen.h"

/*
 * Fill a rectangle in the given color.
 * This is more efficient than scr_rect() with big enough width to fill.
 */
void
scr_fillrectangle(ulx, uly, lrx, lry, color) int ulx, uly, lrx, lry, color;
{
	register int y;

	/* Bounds checking: make sure rectangle is on the screen. */
	if (lrx > scr_lrx)
		lrx = scr_lrx;
	if (lry >= scr_lry)
		lry = scr_lry;
	if (ulx < scr_ulx)
		ulx = scr_ulx;
	if (uly < scr_uly)
		uly = scr_uly;
	if (lrx < ulx || lry < uly)
		return;				/* empty */

	for (y = uly; y <= lry; y++)
		memset(scr_addr(ulx, y), color, lrx + 1 - ulx);
}

/* end of scr_fillrect.c */
