/*
 * scr_recolor.c
 */

#include "screen.h"
#include <string.h>

/*
 * Recolor the screen.
 */
void
scr_recolor()
{
	register char *s;
	register int i, j, tmp;
	char *buf;

	/* Allocate a buffer for the new colors. */
	buf = alloca(scr_ncolors);

	/* Pick a randomized color set. */
	for (i = 0; i < scr_ncolors; i++)
		buf[i] = i;
	for (i = scr_ncolors, s = &buf[scr_ncolors-1]; i > 1; i--, s--) {
		/* Pick random j in [0, i-1], swap buf[i-1] <-> buf[j]. */
		j = rand() % i;			/* range [0, i - 1] */
		tmp = *s;
		*s = buf[j];
		buf[j] = tmp;
	}

	/* Remap the screen colors. */
	for (s = screen; s < screen + scr_npixels; s++)
		*s = buf[*s];
}

/* end of scr_recolor.c */
