/*
 * scr_rect.c
 */

#include "screen.h"

/*
 * Draw a rectangle of the given width in the given color.
 */
void
scr_rectangle(ulx, uly, lrx, lry, width, color) int ulx, uly, lrx, lry, width, color;
{
	register int y, dx, dy;

	/* Bounds checking: make sure rectangle is on the screen. */
	if (lrx > scr_lrx)
		lrx = scr_lrx;
	if (lry >= scr_lry)
		lry = scr_lry;
	if (ulx < scr_ulx)
		ulx = scr_ulx;
	if (uly < scr_uly)
		uly = scr_uly;
	if ((dx = lrx - ulx + 1) <= 0 || (dy = lry - uly) <= 0)
		return;				/* empty */
	else if (2 * width >= dx || 2 * width >= dy) {
		/* Use scr_fillrectangle() if appropriate. */
		scr_fillrectangle(ulx, uly, lrx, lry, color);
		return;
	}
	
	for (y = 0; y < width; y++) {
		/* Top and bottom sides. */
		memset(scr_addr(ulx, uly + y), color, dx);
		memset(scr_addr(ulx, lry - y), color, dx);
	}
	for (y = uly + width; y <= lry - width; y++) {
		/* Left and right sides. */
		memset(scr_addr(ulx, y), color, width);
		memset(scr_addr(lrx - width + 1, y), color, width);
	}
}

/* end of scr_rect.c */
