/*
 * tty_check.c
 */

#include "screen.h"

#define	ESC	0x1B

/*
 * Check for terminal input.
 * ttyinit() has set up the terminal to make read() non-blocking.
 * Return 1 normally, 0 to quit.
 * Type <SP> to pause/resume, 'a' to abort current effect, 'q' or <ESC> to quit.
 */
int
tty_check()
{
	static int done = 0;
	char c;

	if (done)
		return 0;
	if (read(0, &c, 1) != 0) {
		/* Pause after <SP> until another character is typed. */
		if (c == ' ')
			while (read(0, &c, 1) == 0)
				;
		if (c == 'a')
			return 0;
		else if (c == 'q' || c == ESC) {
			++done;
			return 0;
		}
	}
	return 1;
}

/* end of tty_check.c */
