/*
 * tty_init.c
 */

#include <termio.h>

/*
 * Initialize the terminal to allow non-blocking reads.
 * The libvga initialization mungs the terminal too,
 * so this must follow the first vga_setmode() call.
 */
void
tty_init( /* void */ )
{
	struct	termio	termiob;

	ioctl(0, TCGETA, &termiob);		/* get tty mode */
	termiob.c_cc[VMIN] = 0;
	termiob.c_cc[VTIME] = 0;		/* non-blocking read */
	ioctl(0, TCSETA, &termiob);		/* set new mode */
}

/* end of tty_init.c */
